
#include <pwd.h>

#define GLOBAL          /* force GLOBAL decls in ftp_var.h to be declared */
#include "netrc.h"

int
main(int argc, char *argv[])
{
	int erc; 
	struct passwd *pw;
	struct stat sb;
	char 	*cp,
	 	*aname = NULL, 
		*apass = NULL, 
		*aacct = NULL;


	if (argc < 2 ) {
		errx(EXIT_FAILURE, "syntax: servername required");
		return 1;
	}
	
	hostname = argv[1];
	
	/* Begin code borrowed from tnftp::main.c */
	
	netrc[0] = '\0';
	cp = getenv("NETRC");
	if (cp != NULL && strlcpy(netrc, cp, sizeof(netrc)) >= sizeof(netrc))
		errx(1, "$NETRC `%s': %s", cp, strerror(ENAMETOOLONG));

	/*
	 * Cache the user name and home directory.
	 */
	localhome = NULL;
	localname = NULL;
	cp = getenv("HOME");
	if (! EMPTYSTRING(cp))
		localhome = xstrdup(cp);
	pw = NULL;
	cp = getlogin();
	if (cp != NULL)
		pw = getpwnam(cp);
	if (pw == NULL)
		pw = getpwuid(getuid());
	if (pw != NULL) {
		if (localhome == NULL && !EMPTYSTRING(pw->pw_dir))
			localhome = xstrdup(pw->pw_dir);
		localname = xstrdup(pw->pw_name);
	}
	if (netrc[0] == '\0' && localhome != NULL) {
		if (strlcpy(netrc, localhome, sizeof(netrc)) >= sizeof(netrc) ||
		    strlcat(netrc, "/.netrc", sizeof(netrc)) >= sizeof(netrc)) {
			warnx("%s/.netrc: %s", localhome,
			    strerror(ENAMETOOLONG));
			netrc[0] = '\0';
		}
	}
	if (localhome == NULL)
		localhome = xstrdup("/");

	/*   End code borrowed from tnftp::main.c */
	
	if (stat(netrc, &sb) == -1) {
		err(EXIT_FAILURE, "'%s'", netrc);
	}

	erc = ruserpass(hostname, &aname, &apass, &aacct);
	
	if (erc == 0) {
		printf("%30s:\t%s\n%30s:\t%s\n%30s:\t%s\n%30s:\t%s\n", 
			"file", netrc, 
			"machine", hostname, 
			"username", aname, 
			"password", apass);
		return 0;
	}

	return 1;
}

/*
 * strdup() with inbuilt error checking
 */
char *
xstrdup(const char *str)
{
	char *s;

	if (str == NULL)
		errx(1, "xstrdup() called with NULL argument");
	s = strdup(str);
	if (s == NULL)
		err(1, "Unable to allocate memory for string copy");
	return (s);
}
