/*
 * Those parts of tnftp header files needed to parse a .netrc file. 
 */
 
#include <sys/types.h>
#include <sys/param.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <limits.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <err.h>

#ifndef	GLOBAL
#define	GLOBAL	extern
#endif

#define	EMPTYSTRING(x)	((x) == NULL || (*(x) == '\0'))

char   *xstrdup(const char *);
int	ruserpass(const char *, char **, char **, char **);

/*
 * Format of macro table
 */
struct macel {
	char	 mac_name[9];	/* macro name */
	char	*mac_start;	/* start of macro in macbuf */
	char	*mac_end;	/* end of macro in macbuf */
};

GLOBAL	char	 netrc[MAXPATHLEN];	/* path to .netrc file */
GLOBAL	char	*localhome;		/* local home directory */
GLOBAL	char	*localname;		/* local user name */
GLOBAL	char	*hostname;		/* name of host connected to */
GLOBAL	int	 proxy;			/* proxy server connection active */
GLOBAL	int	 macnum;		/* number of defined macros */
GLOBAL	struct macel macros[16];
GLOBAL	char	 macbuf[4096];
GLOBAL	FILE  	*ttyout;	/* stdout, or stderr if retrieving to stdout */



